﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using DirectShowLib;
using SnapShot;
using System.Runtime.InteropServices;
using System.Drawing.Imaging;


namespace CaptureTest
{
    public partial class FormCaptureTest : Form
    {

        private Capture cam;

        public FormCaptureTest()
        {
            InitializeComponent();
            pictureBoxCaptured.SizeMode = PictureBoxSizeMode.Zoom;


            foreach (DsDevice ds in DsDevice.GetDevicesOfCat(FilterCategory.VideoInputDevice))
            {
                comboBoxDevices.Items.Add(ds.Name);
            }
            comboBoxDevices.SelectedIndex = 0;

            try
            {
                cam = new Capture(0, 640, 480, 24, panelPreview); // device, x, y, 24FPS, preview
            }
            catch (Exception ex)
            {
                Console.Error.WriteLine(ex.Message);
            }
            
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (cam != null) cam.Dispose();
        }

        private void comboBoxDevices_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                if(cam != null) cam.Dispose();
                cam = new Capture(comboBoxDevices.SelectedIndex, 640, 480, 24, panelPreview);
            }
            catch (Exception ex)
            {
                Console.Error.WriteLine(ex.Message);
            }
        }

        private void buttonCapture_Click(object sender, EventArgs e)
        {
            IntPtr m_ip = cam.Click();
            Bitmap b = new Bitmap(cam.Width, cam.Height, cam.Stride, PixelFormat.Format24bppRgb, m_ip);
            b.RotateFlip(RotateFlipType.RotateNoneFlipY); // 上下逆さになる事がある
            pictureBoxCaptured.Image = b;
        }

        private void buttonSaveFile_Click(object sender, EventArgs e)
        {
            pictureBoxCaptured.Image.Save("captured.jpg", ImageFormat.Jpeg);
        }

        private void buttonReload_Click(object sender, EventArgs e)
        {
            comboBoxDevices.Items.Clear();
            foreach (DsDevice ds in DsDevice.GetDevicesOfCat(FilterCategory.VideoInputDevice))
            {
                comboBoxDevices.Items.Add(ds.Name);
            }
        }

    }
}
